function CheckForPower(actor)
  --Make sure the teleporter list exists.
  if PowerList == nil then
    PowerList = {};
  end

  actor.listnumX = 0
  actor.listnumY = 0

  local NeedsListX = true
  local NeedsListY = true
  local Merge = false

  local i = 0
  --Checking the powerlist an checks if any is within range of our new power node, merging lists if necessary
  while i <= #PowerList do
    if PowerList[i] == nil then
      PowerList[i] = {1};
    end
    local j = 0
    NeedsListX = false
    while j <= #PowerList[i] do
      if MovableMan:ValidMO(PowerList[i][j]) then
        if SceneMan:ShortestDistance( actor.Pos , PowerList[i][j].Pos , true ).Magnitude <= 480 then
          if NeedsListY == true then
          --if this is the first found, put this in the end of the list
            temp = {#PowerList[i]}
            local k = 0
            while k <= #temp do
              temp[k] = PowerList[i][k]
              k = k + 1
            end
            PowerList[i] = {#temp + 1}
            k = 0
            while k <= #PowerList[i] do
              PowerList[i][k] = temp[k]
              k = k + 1;
            end 
            PowerList[i][#PowerList[i] + 1] = actor;
            print(#PowerList[i])
            actor.listnumY = #PowerList[i];
            NeedsListY = false;
            local fxa = CreateAEmitter("Teleporter Effect A");
            fxa.Pos = actor.Pos;
            MovableMan:AddParticle(fxa);
            actor.listnumX = #PowerList;
          else
            --else merge the newly found object and it's list with the one found previously
            PowerList[actor.listnumX][#PowerList[actor.listnumX]] = PowerList[i][j];
            --move the next lists on the list one down so that we avoid any "holes" in the "overlist"
            local k = 0;
            while k <= #PowerList do
              PowerList[k] = PowerList[k + 1];
              k = k + 1
            end
          end
        end
      end
      j = j + 1
    end
    i = i + 1
  end
  if NeedsListX == true then
    PowerList = {}
  end
  if NeedsListY == true then
    PowerList[#PowerList] = {};
    PowerList[#PowerList][0] = actor;
    actor.listnumX = #PowerList
    actor.listnumY = 0
  end
end

function Create(self)
  CheckForPower(self)
end

function Update(self)
end

function Destroy(self)
  --When destroyed, we need to recalculate all objects in this object's list
  local temp = {};
  local i = 0
  while i <= #PowerList[self.listnumX] do
    if i <= self.listnumY then
      PowerList[self.listnumX][i] = PowerList[self.listnumX][i + 1]
    end
    temp[i] = PowerList[self.listnumX][i]
    PowerList[self.listnumX][i] = nil
    i = i + 1 
  end
  local i = self.listnumX
  while i <= #PowerList do
    PowerList[i] = PowerList[i + 1]
    i = i + 1
  end
  local i = 0
  while i <= #temp do
    CheckForPower(temp[i])
    local fxa = CreateAEmitter("Teleporter Effect B");
    fxa.Pos = self.Pos;
    MovableMan:AddParticle(fxa);
    i = i + 1
  end
end