function Create(self)
  self.SpeedAccel = 3 --what the speed is added with per frame
  self.SpeedAccelMulti = 1.15 --what the speed is added with per frame
  self.StartSpeed = 12 --if a particle has spawned in the field, add its speed with this
  self.StartSpeedMulti = 1.4 --what the speed is added with per frame
  self.Brake = 0.85 --if a particle is moving the opposit way, multiply the speed with this
end

function Update(self)
  for actor in MovableMan.Actors do
    if (actor.Pos.X >= self.Pos.X - 12 - actor.Vel.X) and (actor.Pos.X <= self.Pos.X + 12 + actor.Vel.X) and (actor.Pos.Y >= self.Pos.Y - 12 - actor.Vel.Y) and (actor.Pos.Y <= self.Pos.Y + 12 + actor.Vel.Y) and (actor.PinStrength <= 0) then
      if self.HFlipped == false then
        if actor.Vel.X > 0 then
          actor.Vel = actor.Vel * self.SpeedAccelMulti; -- I don't add the constant to avoid any actors to be sucked out of the bunker.
        else
          actor.Vel.X = actor.Vel.X * self.Brake;
        end
        
        if actor.Vel.X < 0 then
          actor.Vel = actor.Vel * self.SpeedAccelMulti;
        else
          actor.Vel.X = actor.Vel.X * self.Brake;
        end
      end
    end
  end
  for actor in MovableMan.Items do
    if (actor.Pos.X >= self.Pos.X - 20 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 20 + math.abs(actor.Vel.X)) and (actor.Pos.Y >= self.Pos.Y - 12) and (actor.Pos.Y <= self.Pos.Y + 12) and (actor.PinStrength <= 0) then
      if self.HFlipped == false then
        if actor.Vel.X > 0 then
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel = actor.Vel * self.SpeedAccelMulti + (actor.Vel/actor.Vel.Magnitude) * SpeedAccel;
          end
          if actor.Age < 2 then
            actor.Vel = actor.Vel * self.StartSpeedMulti + (actor.Vel/actor.Vel.Magnitude) * self.StartSpeed;
          end
        else
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel.X = actor.Vel.X * self.Brake;
          end
        end
      else
        if actor.Vel.X < 0 then
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel = actor.Vel * self.SpeedAccelMulti + (actor.Vel/actor.Vel.Magnitude) * self.SpeedAccel;
          end
          if actor.Age < 2 then
            actor.Vel = actor.Vel * self.StartSpeedMulti + (actor.Vel/actor.Vel.Magnitude) * self.StartSpeed;
          end
        else
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel.X = actor.Vel.X * self.Brake;
          end
        end
      end
    end
  end
  for actor in MovableMan.Particles do
    if (actor.Pos.X >= self.Pos.X - 20 - math.abs(actor.Vel.X)*0.25) and (actor.Pos.X <= self.Pos.X + 20 + math.abs(actor.Vel.X)*0.25) and (actor.Pos.Y >= self.Pos.Y - 12) and (actor.Pos.Y <= self.Pos.Y + 12) and (actor.PinStrength <= 0) then
             if self.HFlipped == false then
        if actor.Vel.X > 0 then
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel = actor.Vel * self.SpeedAccelMulti + (actor.Vel/actor.Vel.Magnitude) * self.SpeedAccel;
          end
          if actor.Age < 2 then
            actor.Vel = actor.Vel * self.StartSpeedMulti + (actor.Vel/actor.Vel.Magnitude) * self.StartSpeed;
          end
        else
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel.X = actor.Vel.X * self.Brake;
          end
        end
      else
        if actor.Vel.X < 0 then
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel = actor.Vel * self.SpeedAccelMulti + (actor.Vel/actor.Vel.Magnitude) * self.SpeedAccel;
          end
          if actor.Age < 2 then
            actor.Vel = actor.Vel * self.StartSpeedMulti + (actor.Vel/actor.Vel.Magnitude) * self.StartSpeed;
          end
        else
          if (actor.Pos.X >= self.Pos.X - 9 - math.abs(actor.Vel.X)) and (actor.Pos.X <= self.Pos.X + 9 + math.abs(actor.Vel.X)) then
            actor.Vel.X = actor.Vel.X * self.Brake;
          end
        end
      end
    end
  end
end