function Create(self)

  --How long it takes between teleports.
  self.porttime = 500;

  --Timer to count how long since the last teleportation.
  self.porttimer = Timer();
  
  --How long it takes between teleports.
  self.Animatetime = 0;

  
  self.teleporttarget = nil
  self.TargetActor = false
  self.BrainActors = {};
  self.BrainCheck = false
  self.Enabled = true
end

function Update(self)
  if self.Sharpness == 2 then
    self.Sharpness = 1
    self.Enabled = true
  end
  if self.Sharpness == 3 then
    self.Sharpness = 1
    self.Enabled = false
  end
  if self.Enabled then
    self.Frame = 0
  else
    self.Frame = 1
  end
  local Activ = ActivityMan:GetActivity()
  for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
    if Activ:PlayerActive(player) then
      local Brain = Activ:GetPlayerBrain(player)
      if Brain and MovableMan:IsActor(Brain) then
        self.BrainActors[#self.BrainActors + 1] = Activ:GetPlayerBrain(player);
      end
    end
  end
  if self.Animatetime >= 6 then
    self.Animatetime = 0.97
  end
  self.Animatetime = self.Animatetime + 0.03
--  self.Frame = math.floor(self.Animatetime)
  --A delay so that all teleporters will have been placed by the time the code activates.
  if self.porttimer:IsPastSimMS(self.porttime) and Activ.ActivityState ~= Activity.EDITING and (self.Enabled == true or self.Sharpness == 4) then
	  for actor in MovableMan.Actors do
      if (actor.ClassName == "ACrab" or actor.ClassName == "AHuman") and (MovableMan:ValidMO(actor) and actor.Age > 100 and actor.Health > 0 and (actor.Pos.X >= self.Pos.X - 18) and (actor.Pos.X <= self.Pos.X + 18) and (actor.Pos.Y >= self.Pos.Y - 43) and (actor.Pos.Y <= self.Pos.Y - 7) and (actor.PinStrength <= 0) and (actor.Team == self.Team) and actor.Health > 0) then
        local i = #self.BrainActors
        local advance = true
        while i > 0 do
          i = i - 1
          if MovableMan:ValidMO(self.BrainActors[i]) and self.BrainActors[i].ID == actor.ID then
            advance = false
          end
        end
        if advance == true then
          if actor.ClassName == "AHuman" and MovableMan:ValidMO(ToAHuman(actor).EquippedItem) and ToAHuman(actor).EquippedItem.GoldValue > 0 then
            Activ:SetTeamFunds(Activ:GetTeamFunds(self.Team) + ToAHuman(actor).EquippedItem.GoldValue, self.Team)
            ToAHuman(actor).EquippedItem.ToDelete = true
          end
          local fxa = CreateAEmitter("Teleporter Effect A");
          fxa.Pos = self.Pos;
          MovableMan:AddParticle(fxa);
          local i = math.floor(actor.Diameter^2/80)
          while i > 0 do
            i = i - 1
            local fxa = CreateMOPixel("Trade Star Teleporter Node effect");
            local random = math.random()+0.2
            fxa.Pos = (self.Pos + Vector(0 , -25))*random + actor.Pos*(1-random) + Vector(math.random(-actor.Diameter*random*random*0.5, actor.Diameter*random*random*0.5) , math.random(-actor.Diameter*random*random*0.5, actor.Diameter*random*random*0.5));
            fxa.Vel.Y = math.random(-7/random , -6/random)
            fxa.Lifetime = math.random(500*(2-random) , 750*(1.75-random))
            MovableMan:AddParticle(fxa);
          end
          self.porttimer:Reset()
          Activ:SetTeamFunds(Activ:GetTeamFunds(self.Team) + actor.GoldValue * actor.Health * 0.01, self.Team)
          Activ:ReportDeath(self.Team, -1)
          actor:DropAllInventory()
          actor.ToDelete = true
          self.TargetActor = true
        end
		  end
		end
	  for actor in MovableMan.Items do
      if (actor.Pos.X >= self.Pos.X - 18) and MovableMan:ValidMO(actor) and actor.Age > 100 and (actor.Pos.X <= self.Pos.X + 18) and (actor.Pos.Y >= self.Pos.Y - 43) and (actor.Pos.Y <= self.Pos.Y - 7) and (actor.PinStrength <= 0) and actor.GoldValue > 0 then
		    --Create the teleportation effect for both teleporters in the set.
		    local fxa = CreateAEmitter("Teleporter Effect A");
		    fxa.Pos = self.Pos;
		    MovableMan:AddParticle(fxa);
		    local i = math.floor(actor.Diameter/6)
		    while i > 0 do
          i = i - 1
          local fxa = CreateMOPixel("Trade Star Teleporter Node effect");
          local random = math.random()+0.2
          fxa.Pos = actor.Pos + Vector(math.random(-actor.Diameter*random*random*0.5, actor.Diameter*random*random*0.5) , math.random(-actor.Diameter*random*random*0.5, actor.Diameter*random*random*0.5));
          fxa.Vel.Y = math.random(-7/random , -6/random)
          MovableMan:AddParticle(fxa);
		    end
		    self.porttimer:Reset()
		    self.TargetActor = false
        Activ:SetTeamFunds(Activ:GetTeamFunds(self.Team) + actor.GoldValue, self.Team)
        actor.ToDelete = true
		  end
		end
  end
  if self.porttimer:IsPastSimMS(5) and self.TargetActor == true then
    for actor in MovableMan.Items do
      if MovableMan:ValidMO(actor) and (actor.Pos.X + actor.Vel.X*2 >= self.Pos.X - 36-math.abs(actor.Vel.X*5)) and (actor.Pos.X + actor.Vel.X*2 <= self.Pos.X + 36+math.abs(actor.Vel.X*5)) and (actor.Pos.Y + actor.Vel.Y*2 >= self.Pos.Y - 61-math.abs(actor.Vel.Y*5)) and (actor.Pos.Y - actor.Vel.Y*2 <= self.Pos.Y + 11+math.abs(actor.Vel.Y*5)) and (actor.PinStrength <= 0) and actor.GoldValue > 0 then
        Activ:SetTeamFunds(Activ:GetTeamFunds(self.Team) + actor.GoldValue, self.Team)
        actor.ToDelete = true
      end
    end
  end
  if self.porttimer:IsPastSimMS(10) and self.TargetActor == true then
    self.TargetActor = false
  end
  if self.Sharpness == 4 then
    self.Sharpness = 1
    self.Frame = 2
  end
end